import { __awaiter, __generator } from 'tslib';

var _id = 0;
var _reqs = [];
var _cache = {};

function isPending() {
  return !!_reqs.length;
}

function resolve() {
  var requests = Object.keys(_cache).map(function (key) {
    return _cache[key];
  }); // @ts-ignore

  return Promise.allSettled(requests).then(function () {
    _id = 0;
    _reqs = [];
  });
}

function cache(key, loader) {
  if (_cache[key]) return _cache[key];

  _reqs.push(key);

  _cache[key] = loader();

  _cache[key].then(function (res) {
    _cache[key] = res;

    _reqs.splice(_reqs.indexOf(key), 1);
  });

  return null;
}

function load(loader, options) {
  if (options === void 0) {
    options = {};
  }

  var key = options.key || _id++ + "";
  return cache(key, loader);
}
function render(component, ctx, renderer) {
  return __awaiter(this, void 0, void 0, function () {
    var body;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          body = renderer(component, ctx);
          if (!isPending()) return [3
          /*break*/
          , 2];
          return [4
          /*yield*/
          , resolve()];

        case 1:
          _a.sent();

          return [2
          /*return*/
          , render(component, ctx, renderer)];

        case 2:
          _reqs = [];
          return [2
          /*return*/
          , {
            body: body,
            data: _cache
          }];
      }
    });
  });
}

export { load, render };
